from telnetlib import Telnet
import os
import time

class Rasmol:

        def __init__(self, start=0, host='localhost'):

                if start:
                        self.start_rasmol()
                        #time.sleep(5)
                self.connection = self.bind(host)

        def __setitem__(self, item, value):

                self.send('[set %s %s]' % (item, value))
                
        def start_rasmol(self):

                os.system('xterm -iconic -e rasmol &')

        def bind(self, host):
        
                tn = Telnet(host, 21069)
                return tn

        def send(self, cmd):

                self.connection.write("[%s]" % cmd)

        def load(self, file, format='pdb'):

                self.zap()
                self.send("load %s %s" % (format, file))
                

        def zap(self):

                self.send('zap')

        def cartoon(self):

                self.send('cartoon')


        def spinx(self, interval=0.01):
        
                for i in xrange(360):
                        self.send('rotate x 1')
                        time.sleep(interval)

        def spiny(self, interval=0.1):
        
                for i in xrange(360):
                        self.send('rotate y 1')
                        time.sleep(interval)

        def spinz(self, interval=0.1):
        
                for i in xrange(360):
                        self.send('rotate z 1')
                        time.sleep(interval)

        def color(self, s='structure'):

                self.send("color %s" % (s))

        def export(self, file, format='pdb'):
                
                self.send("write %s %s" % (format, file))


        def pause(self, secs=10):

                time.sleep(secs)

        def showmessage(self, msg):

                self.send('echo %s' % (msg))

        def animate(self, LoF, format='pdb', interval=1, *args, **opts):

                for file in LoF:
                        self.load(file, format)
                        for arg in args:
                                self.send(arg)

                        for key, value in opts.items():
                                self[key] = value

                        time.sleep(interval)

        def monitor(self, file, format='pdb', *args):
		fstats = None
		while 1:
			ns = os.stat(file)
			if ns <> fstats:
				fstats = ns
                		self.load(file, format)
                		for arg in args:
                        		self.send(arg)


        def quit(self):
                self.connection.close()

                
