import linusSim, ran

def gen_seeds():
    from random import uniform
    s1 = long(uniform(1.0, ran.M1))
    s2 = long(uniform(1.0, ran.M1))
    s3 = long(uniform(1.0, ran.M1))
    s4 = long(uniform(1.0, ran.M2))
    s5 = long(uniform(1.0, ran.M2))
    s6 = long(uniform(1.0, ran.M2))
    return s1, s2, s3, s4, s5, s6

def run(file, seed=None):
    if seed is None:
        gen = apply(ran.generator, gen_seeds())
    else:
        gen = apply(ran.generator, seed)
        
    sim = linusSim.Linus(file, gen)
    
#Beginning of parameter section
    sim.set_simulation_parameters(numsave=5, 
                                  numcycle=500)
    sim.set_contact_parameters(use_contact=0)
    sim.set_torsion_parameters(use_torsion=1)
    sim.set_hbond_parameters(use_hbond=1,
                         hbond_score_short=0.5,
                         use_sidechain_hbond=1,
                         sidechain_hbond_score=1.0)
#End of parameter section

    sim.run()

if __name__ == "__main__":
    try:
        import psyco
    except ImportError:
        pass
    else:
        psyco.bind(run)  
    import sys, os
    filename = sys.argv[1]

    run(filename)
