#! /usr/local/bin/python2.4
#Lauren Perskie
#6/4/07

import sys, string, pms
from start_functions import options_to_dict,set_dict_option


def get_options(args):

    options = options_to_dict(args);
    options = set_options(options);

    return options

def set_options(options):

    options['-h'] = set_dict_option(options,'-h',0);
    if options['-h'] != 0:
        print_help();
        sys.exit();

    options['-i']         = set_dict_option(options,'-i','');    
    if options['-i'] == '':
        sys.exit('Usage: meso_comp.py [-h] -i <filename> [options]');

    options['-o'] = set_dict_option(options,'-o','');

    return options;

def print_help():

    print """meso_comp.py [-h] -i <filename> [options]
    This program plots densities of mesostate sampling for each residue in a
    protein.  There are 50 residues in each plot.
    Inputs:
           o  -i  name of the input PMS file
           o  -o  name of files to be saved
                  if no name is specified, the name of the input file
                  is used by default
           o  -h  help

    Outputs:
           o  Plots in .ps format.  Note, if there are more than 50 residues in
           the PMS file, multiple files will be saved.

    Example:

          meso_comp.py -i foo.pms -o bar
          If foo.pms has 100 residues, the program will make 2 files:
          bar_1.ps and bar_2.ps
    """

if __name__ == '__main__':

    options = get_options(sys.argv);

    dat = pms.PMS(options['-i'],options['-o']);
    dat.plot_comp();
    
